%define anolis_release 3
%define _sbindir /sbin
%define _binaries_in_noarch_packages_terminate_build 0
%undefine _auto_set_build_flags
%define version_num 6.04

Name:		syslinux
Version:	%{version_num}~pre1
Release:	%{anolis_release}%{?dist}
Summary:	Simple kernel loader which boots from a FAT filesystem

License:	GPLv2+
URL:		http://syslinux.zytor.com/wiki/index.php/The_Syslinux_Project
Source0:	https://mirrors.edge.kernel.org/pub/linux/utils/boot/syslinux/Testing/6.04/%{name}-%{version_num}-pre1.tar.gz

ExclusiveArch:  x86_64
BuildRequires:	gcc, mingw64-gcc
BuildRequires: 	nasm >= 0.98.38-1, perl-interpreter, perl-generators, netpbm-progs
BuildRequires: 	perl(FileHandle)
BuildRequires: 	glibc-devel
BuildRequires: 	libuuid-devel

Requires: 	syslinux-nonlinux = %{version}-%{release}
Requires:	mtools

Patch0: 	0000-Add-install-all-target-to-top-side-of-HAVE_FIRMWARE.patch
Patch1: 	0001-ext4-64bit-feature.patch
Patch2: 	0002-include-sysmacros-h.patch
Patch3: 	0003-Add-RPMOPTFLAGS-to-CFLAGS-for-some-stuff.patch
Patch4: 	0004-Workaround-multiple-definition-of-symbol-errors.patch
Patch5: 	0005-Replace-builtin-strlen-that-appears-to-get-optimized.patch
Patch6:		0007-tweak-for-gcc-10.patch

%description
SYSLINUX is a suite of bootloaders, currently supporting DOS FAT
filesystems, Linux ext2/ext3 filesystems (EXTLINUX), PXE network boots
(PXELINUX), or ISO 9660 CD-ROMs (ISOLINUX).  It also includes a tool,
MEMDISK, which loads legacy operating systems from these media.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%package 	perl
Summary: Syslinux tools written in perl
 
%description 	perl
Syslinux tools written in perl
 
%package 	devel
Summary: 	Headers and libraries for syslinux development.
Provides:	%{name}-static = %{version}-%{release}
 
%description 	devel
Headers and libraries for syslinux development.
 
%package 	extlinux
Summary: 	The EXTLINUX bootloader, for booting the local system.
Requires: 	syslinux
Requires: 	syslinux-extlinux-nonlinux = %{version}-%{release}
 
%description 	extlinux
The EXTLINUX bootloader, for booting the local system, as well as all
the SYSLINUX/PXELINUX modules in /boot.

%package	tftpboot
Summary: 	SYSLINUX modules in /tftpboot, available for network booting
BuildArch: 	noarch

%description 	tftpboot
All the SYSLINUX/PXELINUX modules directly available for network
booting in the /tftpboot directory.

%package 	extlinux-nonlinux
Summary: 	The parts of the EXTLINUX bootloader which aren't run from linux.
Requires: 	syslinux = %{version}-%{release}
BuildArch: 	noarch

%description 	extlinux-nonlinux
All the EXTLINUX binaries that run from the firmware rather than
from a linux host.

%package 	nonlinux
Summary: 	SYSLINUX modules which aren't run from linux.
Requires: 	syslinux = %{version}-%{release}
BuildArch: 	noarch

%description nonlinux
All the SYSLINUX binaries that run from the firmware rather than from a
linux host. It also includes a tool, MEMDISK, which loads legacy operating
systems from media.

%package 	efi64
Summary: 	SYSLINUX binaries and modules for 64-bit UEFI systems
 
%description 	efi64
SYSLINUX binaries and modules for 64-bit UEFI systems

%prep
%autosetup -n %{name}-%{version_num}-pre1 -p1

%build
make RPMCFLAGS='%{optflags}' RPMLDFLAGS='%{build_ldflags}' bios clean all
make RPMCFLAGS='%{optflags}' RPMLDFLAGS='%{build_ldflags}' efi64 clean all

%install
rm -rf %{buildroot} 
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{_prefix}/lib/syslinux
mkdir -p %{buildroot}%{_includedir}
make bios install-all \
	INSTALLROOT=%{buildroot} BINDIR=%{_bindir} SBINDIR=%{_sbindir} \
	LIBDIR=%{_prefix}/lib DATADIR=%{_datadir} \
	MANDIR=%{_mandir} INCDIR=%{_includedir} \
	TFTPBOOT=/tftpboot EXTLINUXDIR=/boot/extlinux \
	LDLINUX=ldlinux.c32

make efi64 install netinstall \
	INSTALLROOT=%{buildroot} BINDIR=%{_bindir} SBINDIR=%{_sbindir} \
	LIBDIR=%{_prefix}/lib DATADIR=%{_datadir} \
	MANDIR=%{_mandir} INCDIR=%{_includedir} \
	TFTPBOOT=/tftpboot EXTLINUXDIR=/boot/extlinux \
	LDLINUX=ldlinux.c32

mkdir -p %{buildroot}%{_pkgdocdir}/sample
install -m 644 sample/sample.* %{buildroot}%{_pkgdocdir}/sample/
mkdir -p %{buildroot}/etc
( cd %{buildroot}/etc && ln -s ../boot/extlinux/extlinux.conf . )
 
# don't ship libsyslinux, at least, not for now
rm -f %{buildroot}%{_prefix}/lib/libsyslinux*
rm -f %{buildroot}%{_includedir}/syslinux.h

%generate_compatibility_deps

%post 		extlinux
# If we have a /boot/extlinux.conf file, assume extlinux is our bootloader
# and update it.
if [ -f /boot/extlinux/extlinux.conf ]; then \
	extlinux --update /boot/extlinux ; \
elif [ -f /boot/extlinux.conf ]; then \
	mkdir -p /boot/extlinux && \
	mv /boot/extlinux.conf /boot/extlinux/extlinux.conf && \
	extlinux --update /boot/extlinux ; \
fi

%files
%dir %{abidir}
%license COPYING
%doc doc/* sample
%{_bindir}/gethostip
%{_bindir}/isohybrid
%{_bindir}/memdiskfind
%{_bindir}/syslinux
%dir %{_datadir}/syslinux
%dir %{_datadir}/syslinux/dosutil
%{_datadir}/syslinux/dosutil/*
%dir %{_datadir}/syslinux/diag
%{_datadir}/syslinux/diag/*
%{_datadir}/syslinux/syslinux64.exe
%{_mandir}/man1/gethostip*
%{_mandir}/man1/syslinux*
%{_mandir}/man1/extlinux*
%{_mandir}/man1/isohybrid*
%{_mandir}/man1/memdiskfind*
%{abidir}/gethostip-option.list
%{abidir}/isohybrid-option.list
%{abidir}/syslinux-option.list

%files doc
%doc NEWS README*

%files 		perl
%license COPYING
%{_bindir}/keytab-lilo
%{_bindir}/lss16toppm
%{_bindir}/md5pass
%{_bindir}/mkdiskimage
%{_bindir}/ppmtolss16
%{_bindir}/pxelinux-options
%{_bindir}/sha1pass
%{_bindir}/syslinux2ansi
%{_bindir}/isohybrid.pl
%{_mandir}/man1/lss16toppm*
%{_mandir}/man1/ppmtolss16*
%{_mandir}/man1/syslinux2ansi*
%{abidir}/pxelinux-options-option.list
%{abidir}/syslinux2ansi-option.list

%files 		devel
%license COPYING
%dir %{_datadir}/syslinux/com32
%{_datadir}/syslinux/com32/*

%files 		extlinux
%config /etc/extlinux.conf
%{_sbindir}/extlinux

%files 		tftpboot
/tftpboot

%files 		nonlinux
%{_datadir}/syslinux/*.com
%{_datadir}/syslinux/*.exe
%{_datadir}/syslinux/*.c32
%{_datadir}/syslinux/*.bin
%{_datadir}/syslinux/*.0
%{_datadir}/syslinux/memdisk

%files		extlinux-nonlinux
/boot/extlinux

%files 		efi64
%license COPYING
%dir %{_datadir}/syslinux/efi64
%{_datadir}/syslinux/efi64

%changelog
* Wed Dec 28 2022 Kun(llfl) <llfl@linux.alibaba.com> - 6.04~pre1-3
- optimise spec

* Thu Oct 13 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 6.04~pre1-2
- optimise spec file & add doc package

* Tue Apr 19 2022 happy_orange <songnannan@linux.alibaba.com> - 6.04~pre1-1
- Init package from upstream
